<?php
class ControllerPaymentGpndata extends Controller {

	private $error = array();
	public function __construct()
	{
		global $registry;
		parent::__construct($registry);

		$file = DIR_SYSTEM . 'library' . DIRECTORY_SEPARATOR . 'gpndata.php';
		if (file_exists($file)){
			include_once($file);
		} else {
			trigger_error('Error: Could not load library ' . $file . '!');
			exit();
		}
		//$connection, $table_prefix, $host = '', $db_name = '', $user = '', $pass = ''
		if($this->_db == null){
			$this->_db = new Database(DB_PREFIX, DB_HOSTNAME, DB_DATABASE, DB_USERNAME, DB_PASSWORD);
		}

		if($this->_API == null){
			$APIUser					= $this->config->get('gpndata_api_user');
			$APIPassword				= $this->config->get('gpndata_api_password');
			$APIKey						= $this->config->get('gpndata_api_key');

			$this->_API					= new GPNDataAPI($APIUser, $APIPassword, $APIKey);
			$this->_API->paymentPageUrl = trim($this->config->get('gpndata_transaction_url'));
			$this->_API->transactionUrl = trim($this->config->get('gpndata_transaction_url_full_api'));
		}
	}

	/** @var GPNDataAPI _API - this is the full API SDK class*/
	private $_API;
	/** @var GpnDataBase _GpnDataBase - this is database manager class*/
	private $_db;

	public function index(){

		$this->load->language('payment/gpndata');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()){

			$this->model_setting_setting->editSetting('gpndata', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title']						= $this->language->get('heading_title');
		$data['text_edit']							= $this->language->get('text_edit');
		$data['notify_url']							= HTTPS_CATALOG . 'index.php?route=payment/gpndata/notify';

		//start labels
		$data['lbl_tab_general']		 			= $this->language->get('lbl_tab_general');
		$data['lbl_tab_order_status']				= $this->language->get('lbl_tab_order_status');
		$data['lbl_description']		 			= $this->language->get('lbl_description');
		$data['lbl_merchant_name']		 			= $this->language->get('lbl_merchant_name');
		$data['lbl_transaction_url']		 		= $this->language->get('lbl_transaction_url');
		$data['lbl_payment_page_url']		 		= $this->language->get('lbl_payment_page_url');
		$data['lbl_transaction_url_full_api']		= $this->language->get('lbl_transaction_url_full_api');
		$data['lbl_contact_url']		 			= $this->language->get('lbl_contact_url');
		$data['lbl_notification_url']		 		= $this->language->get('lbl_notification_url');
		$data['lbl_api_user']						= $this->language->get('lbl_api_user');
		$data['lbl_api_password']					= $this->language->get('lbl_api_password');
		$data['lbl_api_key']						= $this->language->get('lbl_api_key');

		$data['lbl_api_user_placeholder']			= $this->language->get('lbl_api_user_placeholder');
		$data['lbl_api_password_placeholder']		= $this->language->get('lbl_api_password_placeholder');
		$data['lbl_api_key_placeholder']			= $this->language->get('lbl_api_key_placeholder');

		$data['lbl_status']							= $this->language->get('lbl_status');
		$data['lbl_debug_mode']						= $this->language->get('lbl_debug_mode');
		$data['lbl_option_enabled']					= $this->language->get('lbl_option_enabled');
		$data['lbl_option_disabled']				= $this->language->get('lbl_option_disabled');


		// help text
		$data['lbl_description_text']				= $this->language->get('lbl_description_text');
		$data['lbl_merchant_name_text']				= $this->language->get('lbl_merchant_name_text');
		$data['lbl_transaction_url_text']			= $this->language->get('lbl_transaction_url_text');
		$data['lbl_transaction_full_api_text']		= $this->language->get('lbl_transaction_full_api_text');
		$data['lbl_contact_url_text']				= $this->language->get('lbl_contact_url_text');
		$data['lbl_notification_url']				= $this->language->get('lbl_notification_url');
		$data['lbl_notification_url_text']			= $this->language->get('lbl_notification_url_text');
		$data['lbl_api_user_text']					= $this->language->get('lbl_api_user_text');
		$data['lbl_api_password_text']				= $this->language->get('lbl_api_password_text');
		$data['lbl_api_key_text']					= $this->language->get('lbl_api_key_text');

		//status help text
		$data['help_tooltip_status_void']			= $this->language->get('help_tooltip_status_void');
		$data['help_tooltip_status_declined']		= $this->language->get('help_tooltip_status_declined');
		$data['help_tooltip_status_captured']		= $this->language->get('help_tooltip_status_captured');
		$data['help_tooltip_status_pending']		= $this->language->get('help_tooltip_status_pending');
		$data['help_tooltip_status_refunded']		= $this->language->get('help_tooltip_status_refunded');
		$data['help_tooltip_status_refund_pending']	= $this->language->get('help_tooltip_status_refund_pending');
		$data['help_tooltip_status_chargeback']		= $this->language->get('help_tooltip_status_chargeback');
		$data['help_tooltip_contact_url']			= $this->language->get('help_tooltip_contact_url');
		$data['help_debug_mode']					= $this->language->get('help_debug_mode');

		//buttons
		$data['button_save']						= $this->language->get('button_save');
		$data['button_cancel']						= $this->language->get('button_cancel');

		//status
		$data['gpndata_status_declined']			= $this->language->get('gpndata_status_declined');
		$data['gpndata_status_void']			    = $this->language->get('gpndata_status_void');
		$data['gpndata_status_captured']			= $this->language->get('gpndata_status_captured');
		$data['gpndata_status_pending']			    = $this->language->get('gpndata_status_pending');
		$data['gpndata_status_refund']	            = $this->language->get('gpndata_status_refund');
		$data['gpndata_status_refund_pending']	    = $this->language->get('gpndata_status_refund_pending');
		$data['gpndata_status_chargeback']	        = $this->language->get('gpndata_status_chargeback');

		//errors
		$data['error_payment_page_three'] 			= $this->language->get('error_payment_page_three');
		$data['error_field_must_have_value'] 		= $this->language->get('error_field_must_have_value');
		$data['gpndata_notification_url']    		= HTTPS_CATALOG . 'index.php?route=payment/gpndata/notify';

		$data['text_status_please_set_status']		= $this->language->get('text_status_please_set_status');
		$data['text_debug_mode_enabled']			= $this->language->get('text_debug_mode_enabled');

		if(isset($this->error['warning'])){
			$data['error_warning']	= $this->error['warning'];
		}
		else{
			$data['error_warning']	= '';
		}

		if(isset($this->error['error_merchant_id'])){
			$data['error_merchant_id'] = $this->error['error_merchant_id'];
		}
		else{
			$data['error_merchant_id'] = '';
		}

		$data['store_ssl_enabled']			= $this->config->get('config_secure');
		$data['text_ssl_must_be_enabled']	= $this->language->get('text_ssl_must_be_enabled');

		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array(
		    'text' => $this->language->get('text_home'),
		    'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
		    'text' => $this->language->get('text_payment'),
		    'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('payment/gpndata', 'token=' . $this->session->data['token'], 'SSL');
		$data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');

		$data['gpndata_description']					= isset($this->request->post['gpndata_description']) ? $this->request->post['gpndata_description'] : $this->config->get('gpndata_description');
		$data['gpndata_merchant_name']					= isset($this->request->post['gpndata_merchant_name']) ? $this->request->post['gpndata_merchant_name'] : $this->config->get('gpndata_merchant_name');
		$data['gpndata_transaction_url']				= isset($this->request->post['gpndata_transaction_url']) ? $this->request->post['gpndata_transaction_url'] : $this->config->get('gpndata_transaction_url');
		$data['gpndata_transaction_url_full_api']		= isset($this->request->post['gpndata_transaction_url_full_api']) ? $this->request->post['gpndata_transaction_url_full_api'] : $this->config->get('gpndata_transaction_url_full_api');
		$data['gpndata_contact_url']					= isset($this->request->post['gpndata_contact_url']) ? $this->request->post['gpndata_contact_url'] : $this->config->get('gpndata_contact_url');
		$data['gpndata_api_user']						= isset($this->request->post['gpndata_api_user']) ? $this->request->post['gpndata_api_user'] : $this->config->get('gpndata_api_user');
		$data['gpndata_api_password']					= isset($this->request->post['gpndata_api_password']) ? $this->request->post['gpndata_api_password'] : $this->config->get('gpndata_api_password');
		$data['gpndata_api_key']						= isset($this->request->post['gpndata_api_key']) ? $this->request->post['gpndata_api_key'] : $this->config->get('gpndata_api_key');
		$data['gpndata_error_field_must_have_value']	= isset($this->request->post['error_field_must_have_value']) ? $this->request->post['error_field_must_have_value']
		: $this->config->get('error_field_must_have_value');
		$data['gpndata_status']							= isset($this->request->post['gpndata_status']) ? $this->request->post['gpndata_status'] : $this->config->get('gpndata_status');
		$data['gpndata_debug_mode']						= isset($this->request->post['gpndata_debug_mode']) ? $this->request->post['gpndata_debug_mode'] : $this->config->get('gpndata_debug_mode');


		//status

		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$data['gpndata_status_captured_id'] = isset($this->request->post['gpndata_status_captured_id']) ? $this->request->post['gpndata_status_captured_id'] :
		$this->config->get('gpndata_status_captured_id');

		$data['gpndata_status_declined_id'] = isset($this->request->post['gpndata_status_declined_id']) ? $this->request->post['gpndata_status_declined_id'] :
		$this->config->get('gpndata_status_declined_id');

		$data['gpndata_status_void_id'] = isset($this->request->post['gpndata_status_void_id']) ? $this->request->post['gpndata_status_void_id'] :
		$this->config->get('gpndata_status_void_id');

		$data['gpndata_status_pending_id'] = isset($this->request->post['gpndata_status_pending_id']) ? $this->request->post['gpndata_status_pending_id'] :
		$this->config->get('gpndata_status_pending_id');

		$data['gpndata_status_refund_id'] = isset($this->request->post['gpndata_status_refund_id']) ? $this->request->post['gpndata_status_refund_id'] :
		$this->config->get('gpndata_status_refund_id');

		$data['gpndata_status_refund_pending_id'] = isset($this->request->post['gpndata_status_refund_pending_id']) ? $this->request->post['gpndata_status_refund_pending_id'] :
		$this->config->get('gpndata_status_refund_pending_id');

		$data['gpndata_status_chargeback_id'] = isset($this->request->post['gpndata_status_chargeback_id']) ? $this->request->post['gpndata_status_chargeback_id'] :
		$this->config->get('gpndata_status_chargeback_id');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/gpndata.tpl', $data));
	}

	public function install(){
		$database = new Database(DB_PREFIX, DB_HOSTNAME, DB_DATABASE, DB_USERNAME, DB_PASSWORD);
		$database->createTables();
		unset($database);
	}

	public function uninstall(){

		$database = new Database(DB_PREFIX, DB_HOSTNAME, DB_DATABASE, DB_USERNAME, DB_PASSWORD);
		$database->dropTables();
		unset($database);
	}

	public function order() {

		if($this->config->get('gpndata_status')){

			$this->load->language('payment/gpndata');
			$order_id = (int)$this->request->get['order_id'];
			$order = $this->_db->getOrder($order_id, true);

			if(!empty($order)){

				$data['total_amount']								= $this->_API->formatAmount($order['total_amount']);
				$order['total_formatted']							= $this->currency->format($order['total_amount'], $order['curcode'], 1, true);

				$last_transaction_state								= $this->_API->checkTransactionStatus($order['merchant_trans_id'], $order['gate_trans_id']);
				$state												= $last_transaction_state->transaction->state;
				$description										= $last_transaction_state->transaction->description;


				$data['text_transaction_current_state']				= $this->language->get('text_transaction_current_state');
				$data['transaction_current_state']					= $state;

				$data['text_transaction_current_state_description'] = $this->language->get('text_transaction_current_state_description');
				$data['transaction_current_state_description']		=  $description;

				$data['button_refund']								= $this->language->get('button_refund');
				$data['text_payment_refunded']						= $this->language->get('text_payment_refunded');
				$data['text_column_date_added']						= $this->language->get('text_column_date_added');
				$data['text_column_date_modified']					= $this->language->get('text_column_date_modified');
				$data['text_order_ref']								= $this->language->get('text_order_ref');
				$data['text_currency']								= $this->language->get('text_currency');

				$data['text_column_description']					= $this->language->get('text_column_description');
				$data['text_column_additional_text']				= $this->language->get('text_column_additional_text');
				$data['text_column_error_message']					= $this->language->get('text_column_error_message');

				$data['gpndata_order']								= $order;
				$data['text_payment_info']							= $this->language->get('text_payment_info');

				$data['text_order_total']							= $this->language->get('text_order_total');
				$data['text_total_captured']						= $this->language->get('text_total_captured');
				$data['text_capture_status']						= $this->language->get('text_capture_status');

				$data['text_transactions']							= $this->language->get('text_transactions');
				$data['text_yes']									= $this->language->get('text_yes');
				$data['text_no']									= $this->language->get('text_no');
				$data['text_column_amount']							= $this->language->get('text_column_amount');
				$data['text_column_status']							= $this->language->get('text_column_status');


				$data['button_capture']								= $this->language->get('button_capture');

				$data['button_void']								= $this->language->get('button_void');
				$data['text_void_status']							= $this->language->get('text_void_status');


				$data['text_capture_request']						= $this->language->get('text_capture_request');
				$data['text_capture_cancel_request']				= $this->language->get('text_capture_cancel_request');

				$data['modal_refund_reason_input_text']				= $this->language->get('modal_refund_reason_input_text');
				$data['modal_refund_reason_input_placeholder_text'] = $this->language->get('modal_refund_reason_input_placeholder_text');
				$data['modal_refund_amount_input_text']				= $this->language->get('modal_refund_amount_input_text');
				$data['modal_refund_amount_input_placeholder_text'] = $this->language->get('modal_refund_amount_input_placeholder_text');
				$data['modal_refund_button_refund_text']			= $this->language->get('modal_refund_button_refund_text');
				$data['modal_refund_title_text']					= $this->language->get('modal_refund_title_text');
				$data['modal_refund_subtitle_text']					= $this->language->get('modal_refund_subtitle_text');

				$data['text_void_reason']							= $this->language->get('text_void_reason');
				$data['modal_void_reason_input_text']				= $this->language->get('modal_void_reason_input_text');

				$data['text_close']									= $this->language->get('text_close');
				$data['token']										= $this->session->data['token'];
                $data['order_id']									= $order_id;

				return $this->load->view('payment/gpndata_order.tpl', $data);
			}
		}
	}

	//pre versions opencart support for order_info
	public function orderAction() {
		return $this->order();
	}

	public function capture(){

		if ($this->request->server['REQUEST_METHOD'] === 'POST' && isset($this->request->post['order_id']) && isset($this->request->post['capture_amount'])){

			$this->load->language('payment/gpndata');
			$text_success_capture		= $this->language->get('text_success_capture');
			$text_api_command_executed	= $this->language->get('text_api_command_executed');

			$capture_amount				= $this->_API->formatAmount($this->request->post['capture_amount']);
			$order_id					= (int)$this->request->post['order_id'];
			$order						= $this->_db->getOrder($order_id);


			$APIRequest					= $this->_API->requestCaptureAuthorization($order['gate_trans_id'], $capture_amount);
			$result						= $APIRequest->getTransactionResult();
			$errormessage				= $APIRequest->getErrorMsg();

			if($result == TransactionStatus::ERROR){

                $transaction_status = $result;
                $description		= $errormessage;
                $captured_amount	= 0.00;
            }
            else if($result == TransactionStatus::SUCCESS){

                $description		= $text_success_capture. $capture_amount.' '.$order['curcode'];
				$this->_db->updateOrder(array('order_id' =>	$order_id, 'is_captured' => 1));
            }
			else{

				$transaction_status = $result;
				$description		= $this->language->get('text_transaction_status_unknown').$result;
				$captured_amount	= 0.00;
			}

            $transactionData = array(
								'order_id'	=> $order_id,
								'status'			=> "$result",
								'state'				=> "$result",
								'description'		=> "$description",
								'amount'			=> "$capture_amount",
								'additional_text'	=> "$text_api_command_executed"
								);

			$this->_db->addTransaction($transactionData);
			$order  = $this->_db->getLastTransaction($order_id);

            header('Content-Type: application/json');
            $this->response->setOutput(json_encode($order));
		}
	}

	public function refund(){

		$is_refunded = 0;
		if($this->request->server['REQUEST_METHOD'] === 'POST' && isset($this->request->post['refund_amount']) && isset($this->request->post['refund_reason']) && isset($this->request->post['order_id'])){

			$this->load->language('payment/gpndata');
            $order_id       = (int)$this->request->post['order_id'];
            $refund_reason  = $this->request->post['refund_reason'];
            $refund_amount  = $this->_API->formatAmount($this->request->post['refund_amount']);


            $order          = $this->_db->getOrder($order_id);
            $APIRequest     = $this->_API->refundTransaction($order['gate_trans_id'], $refund_amount, $refund_reason);
			$result			= $APIRequest->getTransactionResult();
			$errormessage	= $APIRequest->getErrorMsg();
			$status			= null;
			$reason			= $this->language->get('text_refund_reason').$refund_reason;

            if($result == TransactionStatus::ERROR){
                $transaction_status = $result;
                $description		= $errormessage;
                $refundAmount		= 0.00;
            }
            else{

                $transaction_status = '';
                if($result == TransactionStatus::SUCCESS){
                    $transaction_status = TransactionStatus::REFUNDED;
                    $description	    = $this->language->get('text_refunded_amount').$refund_amount. ' '.$order['curcode'];
                }
                elseif($result == TransactionStatus::REQUEST_PENDING)
                {
					//$order_id, $status, $description
                    $transaction_status = 'REQUEST PENDING';
                    $description		= $this->language->get('text_to_be_refund_amount'). $refund_amount. ' '.$order['curcode'];
					$this->session->data['orderHistoryData'] = array(
																'order_id'		=> $order_id,
																'status'		=> $this->config->get('gpndata_status_refund_pending_id'),
																'description'	=> $description,
																'token'			=> $this->session->data['token']);
                }
                else{

                    $transaction_status = $result;
                    $description		= $this->language->get('text_transaction_status_unknown').$result;
                    $refundAmount		= 0.00;
                }
            }


            $transactionData = array(
								'order_id'			=> (int)$order['order_id'],
								'status'			=> "$transaction_status",
								'state'				=> "$transaction_status",
								'description'		=> "$description",
								'amount'			=> "$refund_amount",
								'additional_text'	=> "$reason"
								);

            $this->_db->addTransaction($transactionData);
            $this->_db->updateOrder(array('order_id' => $order_id, 'is_refund_pending' => 1));
            $order  = $this->_db->getLastTransaction($order_id);
            header('Content-Type: application/json');
            $this->response->setOutput(json_encode($order));
        }
    }

	public function void(){

		if ($this->request->server['REQUEST_METHOD'] === 'POST' && isset($this->request->post['order_id'])
			&& isset($this->request->post['void_reason'])){

			$this->load->language('payment/gpndata');
			$text_api_command_executed		= $this->language->get('text_api_command_executed');

			$order_id						= (int)$this->request->post['order_id'];
			$order							= $this->_db->getOrder($order_id);
			$APIRequest						= $this->_API->requestCancelAuthorization($order['gate_trans_id']);
			$result							= $APIRequest->getTransactionResult();
			$errormessage					= $APIRequest->getErrorMsg();

			$amount							= $order['total_amount'];
			$order_status					= $this->config->get('gpndata_status_void_id');
			$text_success_void				= $this->language->get('text_success_void');
			$text_capture_cancel_request	= $this->language->get('text_capture_cancel_request');
			$additional_text				= $this->language->get('modal_void_reason_input_text').' : '.$this->request->post['void_reason'];

			if(empty($errormessage) && $result == TransactionStatus::CANCELED){
				$this->_db->updateOrder(array('order_id' => $order_id, 'is_voided' => 1));

				$description		= empty($errormessage) ?  $text_success_void : $text_capture_cancel_request;
				$transactionData	= array(
										'order_id'			=> (int)$order_id,
										'status'			=> "$result",
										'state'				=> "$result",
										'description'		=> "$text_success_void",
										'amount'			=> "$amount",
										'additional_text'	=> "$additional_text"
											 );
			}
			else{
				$transactionData = array(
									'order_id'			=> (int)$order_id,
									'status'			=> "$result",
									'state'				=> "$result",
									'errormessage'		=> "$errormessage",
									'additional_text'	=> "$text_capture_cancel_request",
									'amount'			=> "$amount"
										);
			}

			$this->_db->addTransaction($transactionData);
			$order  = $this->_db->getLastTransaction($order_id);

			header('Content-Type: application/json');
			$this->response->setOutput(json_encode($order));
		}
	}

	protected function validate() {

		if (!$this->user->hasPermission('modify', 'payment/gpndata')) {
			$this->error['warning'] = $this->language->get('error_field_must_have_value');
		}

		if (!$this->request->post['gpndata_transaction_url']) {
			$this->error['error_field_must_have_value'] = $this->language->get('error_field_must_have_value');
		}
		if (!$this->request->post['gpndata_transaction_url_full_api']) {
			$this->error['error_field_must_have_value'] = $this->language->get('error_field_must_have_value');
		}
		if (!$this->request->post['gpndata_contact_url']) {
			$this->error['error_field_must_have_value'] = $this->language->get('error_field_must_have_value');
		}
		if (!$this->request->post['gpndata_api_user']) {
			$this->error['error_field_must_have_value'] = $this->language->get('error_field_must_have_value');
		}

		if (!$this->request->post['gpndata_api_password']) {
			$this->error['error_field_must_have_value'] = $this->language->get('error_field_must_have_value');
		}
		if (!$this->request->post['gpndata_api_key']) {
			$this->error['error_field_must_have_value'] = $this->language->get('error_field_must_have_value');
		}

		return !$this->error;
	}
}