<?php
class ModelPaymentGpndata extends Model {

	public function __construct() 
	{
		global $registry;
		parent::__construct($registry);

		//GPN DATA API library - this is a workaround so extension is supported in v.2+ of opencart
		//$file = DIR_SYSTEM . 'library\\gpndata.php';
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
			$file = DIR_SYSTEM . 'library\\gpndata.php';
		} else {
			$file = DIR_SYSTEM . 'library/gpndata.php';
		}
		if (file_exists($file)){
			include_once($file);
		} else {
			trigger_error('Error: Could not load library ' . $file . '!');
			exit();
		}
		
		if($this->_API == null){

			$APIUser = $this->config->get('gpndata_api_user');
			$APIPassword = $this->config->get('gpndata_api_password');
			$APIKey = $this->config->get('gpndata_api_key');
			
			$this->_API = new GPNDataAPI($APIUser, $APIPassword, $APIKey);
			$this->_API->paymentPageUrl = trim($this->config->get('gpndata_transaction_url'));
			$this->_API->transactionUrl = trim($this->config->get('gpndata_transaction_url_full_api'));
		}
	}
	
	public function getMethod($address, $total) {
		
        $this->load->language('payment/gpndata');		
        $status = $this->config->get('gpndata_status');
        $method_data = array();

		if ($status){
			$method_data = array(
				'code'       => 'gpndata',
				'title'      => 'GPN Data International',
				'terms'      => '',
				'sort_order' => '1');
		}

		return $method_data;
	}
			
}
